*
*       This program copies files as fast as the hardware (ie the medium)
*       can cope. Written by David Burns, 8/8/87.
*
        include ram1_macro_lib
        include ram1_qdos1_in
        include ram1_qdos2_in
*
ut.mtext        equ     $d0
*
        section FCOPY
*
        data    128
*
mxdvnam equ     42
*
entry
        bra.s   start
        ds.b    4
        dc.w    $4afb
        string$ 'FCOPY'
*
namecon string$ 'con_252x20a2x181'
        ds.b    32-(*-namecon)
messag1 string$ {'Source ? '}
messag2 string$ {'Destination ? '}
*
start   add.l   a4,a6
        moveq   #err.bp,d0
        move.w  (sp)+,d1
        beq.s   getname
        subq.w  #2,d1
        bne     error
        move.l  (sp)+,a4
        move.l  (sp)+,a5
        bra     hop1
getname
        moveq   #-1,d1
        moveq   #2,d3
        lea     namecon,a0
        qdosoc$ io.open
        tst.l   d0
        bne     error
        moveq   #-1,d3
        qdosio$ sd.clear
        lea     messag1,a1
        move.w  ut.mtext,a3
        jsr     (a3)
        moveq   #mxdvnam,d2
        move.l  a6,a5
        addq.l  #2,a5
        move.l  a5,a1
        qdosio$ io.fline
        tst.l   d0
        bne     error
        subq.w  #1,d1
        move.w  d1,(a6)
        moveq   #-1,d1
        moveq   #1,d3
        move.l  a0,a4
        move.l  a6,a0
        qdosoc$ io.open
        tst.l   d0
        bne     error
        exg     a0,a4
        moveq   #-1,d3
        qdosio$ sd.nl
        lea     messag2,a1
        move.w  ut.mtext,a3
        jsr     (a3)
        moveq   #mxdvnam,d2
        move.l  a5,a1
        qdosio$ io.fline
        tst.l   d0
        bne     error
        subq.w  #1,d1
        move.w  d1,(a6)
        moveq   #-1,d1
        moveq   #3,d3
        move.l  a6,a0
        qdosoc$ io.open
        tst.l   d0
        bne     error
        move.l  a0,a5
hop1
        moveq   #14,d2
        moveq   #-1,d3
        move.l  a4,a0
        move.l  a6,a1
        qdosio$ fs.headr
        tst.l   d0
        bne.s   error
        move.l  a5,a0
        move.l  a6,a1
        qdosio$ fs.heads
        tst.l   d0
        bne.s   error
*
        qdosmt$ mt.free
        moveq   #err.om,d0
        asr.l   #1,d1
        moveq   #-2,d2
        and.l   d2,d1
        beq.s   error
        move.l  #1024,d2
        cmp.l   d2,d1
        bls.s   hop2
        move.l  d2,d1
hop2
        move.l  (a6),d3
        addq.l  #2,d3
        and.b   #%11111110,d3
        cmp.l   d1,d3
        bls.s   getfmem
        move.l  d1,d3
getfmem
        moveq   #-1,d1
        moveq   #8,d2
        move.l  d2,a1
        subq.l  #8,a1
        qdosmt$ mt.cjob
        tst.l   d0
        bne.s   error
        move.l  d3,d4
        move.l  a0,a3
        addq.l  #8,a3
        moveq   #-1,d3
        moveq   #err.ef,d5
        clr.b   d6
loop
        move.l  d4,d2
        move.l  a4,a0
        move.l  a3,a1
        qdosio$ io.fstrg
        cmp.l   d0,d5
        bne.s   hop3
        clr.l   d0
        moveq   #1,d6
        bra.s   hop4
hop3
        tst.l   d0
        bne.s   error
hop4
        move.w  d1,d2
        beq.s   error
        move.l  a5,a0
        move.l  a3,a1
        qdosio$ io.sstrg
        tst.l   d0
        bne.s   error
        tst.b   d6
        beq.s   loop
error
        move.l  d0,d3
        moveq   #-1,d1
        qdosmt$ mt.frjob
        end
